Index: trunk/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 100)
@@ -78,4 +78,5 @@
   m_uiSubSampExpX       = uiSubSampExpX;
   m_uiSubSampExpY       = uiSubSampExpY;
+#if !QC_MULTI_DIS_CAN
   m_ppcYuv              = new TComYuv*    [ m_uiMaxDepth ];
   m_ppcCU               = new TComDataCU* [ m_uiMaxDepth ];
@@ -91,4 +92,5 @@
   m_cTmpPic.create( uiPicWidth >> m_uiSubSampExpX, uiPicHeight >> m_uiSubSampExpY, uiMaxCUWidth >> m_uiSubSampExpX, uiMaxCUHeight >> m_uiSubSampExpY, uiMaxCUDepth );
   xSetChroma( &m_cTmpPic, ( 1 << uiOrgBitDepth ) >> 1 );
+#endif
   m_bCreated    = true;
 }
@@ -100,4 +102,5 @@
   {
     m_bCreated    = false;
+#if !QC_MULTI_DIS_CAN
     for( UInt uiDepth = 0; uiDepth < m_uiMaxDepth; uiDepth++ )
     {
@@ -114,4 +117,5 @@
     delete [] m_ppcCU;  m_ppcCU  = 0;
     m_cTmpPic.destroy();
+#endif
     m_uiMaxDepth          = 0;
     m_uiOrgDepthBitDepth  = 0;
@@ -163,5 +167,7 @@
   m_bPDMAvailable = false;
   m_uiCurrViewId  = pcPic->getSPS()->getViewId();
-
+#if PDM_REMOVE_DEPENDENCE
+  pcPic->setStoredPDMforV2(0);
+#endif
   // update SPS list and AU pic list and set depth map generator in SPS
 #if VIDYO_VPS_INTEGRATION
@@ -218,6 +224,10 @@
   if( m_uiCurrViewId )
   {
+#if PDM_REMOVE_DEPENDENCE
+    UInt      uiBaseVId   = m_auiBaseIdList[0];
+#else
     Bool      bCheckVId1  = ( m_uiCurrViewId > 1 && m_auiBaseIdList[0] == 0 );
     UInt      uiBaseVId   = ( bCheckVId1 ? 1 : m_auiBaseIdList[0] );
+#endif
     TComPic*  pcBasePic   = m_pcAUPicAccess->getPic( uiBaseVId );
     SliceType eSliceType  = pcBasePic->getCurrSlice()->getSliceType();
@@ -367,5 +377,5 @@
 }
 
-
+#if !QC_MULTI_DIS_CAN
 Bool
 TComDepthMapGenerator::predictDepthMap( TComPic* pcPic )
@@ -398,4 +408,7 @@
         pcBasePic->addPrdDepthMapBuffer( PDM_SUB_SAMP_EXP_X(m_pcSPSAccess->getPdm()), PDM_SUB_SAMP_EXP_Y(m_pcSPSAccess->getPdm()) );
         xClearDepthMap( pcBasePic );
+#if PDM_REMOVE_DEPENDENCE
+        xClearDepthMap( pcBasePic, PDM_UNDEFINED_DEPTH, 1 );
+#endif
       }
 #if PDM_OUTPUT_PRED_DEPTH_MAP
@@ -442,4 +455,7 @@
   {
     xClearDepthMap( pcPic );
+#if PDM_REMOVE_DEPENDENCE
+    xClearDepthMap( pcPic, PDM_UNDEFINED_DEPTH, 1 );
+#endif
   }
   return bUndefined;
@@ -463,4 +479,14 @@
 
   // predict depth map using current coding symbols
+#if PDM_REMOVE_DEPENDENCE
+  pcPic->setStoredPDMforV2(0);
+  xPredictDepthMap( pcPic );
+  if(m_uiCurrViewId==0)
+  {
+    pcPic->setStoredPDMforV2(1);
+    xPredictDepthMap( pcPic );
+    pcPic->setStoredPDMforV2(0);
+  }
+#else
   xPredictDepthMap( pcPic );
 #if PDM_OUTPUT_PRED_DEPTH_MAP
@@ -469,4 +495,5 @@
     dumpDepthMap( pcPic, acFilenameBase );
   }
+#endif
 #endif
 
@@ -481,4 +508,15 @@
 #endif
   }
+#if PDM_REMOVE_DEPENDENCE
+  if( m_uiCurrViewId == 2 )
+  {
+    TComPic* pcBasePic = m_pcAUPicAccess->getPic( 0 );
+    AOF( pcBasePic );
+    xConvertDepthMapCurr2Ref( pcBasePic, pcPic );
+#if PDM_OUTPUT_PRED_DEPTH_MAP
+    dumpDepthMap( pcBasePic, acFilenameBase );
+#endif
+  }
+#endif
 }
 
@@ -501,4 +539,8 @@
   Int         iSrcStride  = pcPicYuv->getStride   ();
   Int         iDstStride  = m_cTmpPic.getStride   ();
+#if PDM_REMOVE_DEPENDENCE
+  if(pcPic->getStoredPDMforV2())
+     pcPicYuv    = pcPic->getPredDepthMapTemp();
+#endif
   Pel*        pSrcSamples = pcPicYuv->getLumaAddr ( 0 );
   Pel*        pDstSamples = m_cTmpPic.getLumaAddr ( 0 );
@@ -520,5 +562,5 @@
   m_cTmpPic.dump( acFilename, ( pcPic->getPOC() != 0 )  );
 }
-
+#endif
 
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -563,7 +605,155 @@
 
 #if HHI_INTER_VIEW_MOTION_PRED
+#if QC_MULTI_DIS_CAN
+Int
+TComDepthMapGenerator::getPdmMergeCandidate( TComDataCU* pcCU, UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo )
+#else
 Int
 TComDepthMapGenerator::getPdmMergeCandidate( TComDataCU* pcCU, UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv )
-{
+#endif 
+{
+#if MTK_INTERVIEW_MERGE_A0049
+  AOF  ( m_bCreated && m_bInit );
+
+#if !QC_MULTI_DIS_CAN
+  ROFRS( m_bPDMAvailable, 0 );
+#endif
+
+  TComSlice*    pcSlice     = pcCU->getSlice ();
+  TComSPS*      pcSPS       = pcSlice->getSPS();
+  AOF  ( pcSPS->getViewId() == m_uiCurrViewId );
+  Bool          bPdmMerge   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_MERGE ) == PDM_USE_FOR_MERGE );
+  ROTRS( !bPdmMerge, 0 );
+
+  Bool abPdmAvailable[2] = {false,false};
+
+  Int iValid = 0;
+  Int iViewId = 0;
+  for( UInt uiBId = 0; uiBId < m_uiCurrViewId && iValid==0; uiBId++ )
+  {
+    UInt        uiBaseId    = m_auiBaseIdList[ uiBId ];
+    TComPic*    pcBasePic   = m_pcAUPicAccess->getPic( uiBaseId );
+    for( Int iRefListId = 0; iRefListId < 2 && iValid==0; iRefListId++ )
+    {
+      RefPicList  eRefPicListTest = RefPicList( iRefListId );
+      Int         iNumRefPics = pcSlice->getNumRefIdx( eRefPicListTest ) ;
+      for( Int iRefIndex = 0; iRefIndex < iNumRefPics; iRefIndex++ )
+      { 
+        if(pcBasePic->getPOC() == pcSlice->getRefPic( eRefPicListTest, iRefIndex )->getPOC() 
+          && pcBasePic->getViewId() == pcSlice->getRefPic( eRefPicListTest, iRefIndex )->getViewId())
+        {
+          iValid=1;
+          iViewId = uiBaseId;
+          break;
+        }
+      }
+    }
+  }
+  if (iValid == 0)
+    return 0;
+
+  //--- get base CU/PU and check prediction mode ---
+  TComPic*    pcBasePic   = m_pcAUPicAccess->getPic( iViewId );
+  TComPicYuv* pcBaseRec   = pcBasePic->getPicYuvRec   ();
+
+#if QC_MULTI_DIS_CAN
+  Int  iCurrPosX, iCurrPosY;
+  UInt          uiPartAddr;
+  Int           iWidth;
+  Int           iHeight;
+
+  pcCU->getPartIndexAndSize( uiPartIdx, uiPartAddr, iWidth, iHeight );
+  pcBaseRec->getTopLeftSamplePos( pcCU->getAddr(), pcCU->getZorderIdxInCU() + uiPartAddr, iCurrPosX, iCurrPosY );
+  iCurrPosX  += ( ( iWidth  - 1 ) >> 1 );
+  iCurrPosY  += ( ( iHeight - 1 ) >> 1 );
+
+  Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (pDInfo->m_acMvCand[0].getHor() + 2 ) >> 2 ) );
+  Int         iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCurrPosY + ( (pDInfo->m_acMvCand[0].getVer() + 2 ) >> 2 )); 
+  Int         iBaseCUAddr;
+  Int         iBaseAbsPartIdx;
+  pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY , iBaseCUAddr, iBaseAbsPartIdx );
+#else
+  Int  iPrdDepth, iCurrPosX, iCurrPosY;
+  Bool bAvailable  = xGetPredDepth( pcCU, uiPartIdx, iPrdDepth, &iCurrPosX, &iCurrPosY );
+  AOF( bAvailable );
+  TComPicYuv* pcBasePdm   = pcBasePic->getPredDepthMap();
+  Int         iDisparity  = xGetDisparityFromVirtDepth( iViewId, iPrdDepth );
+  Int         iShiftX     = m_uiSubSampExpX + 2;
+  Int         iAddX       = ( 1 << iShiftX ) >> 1;
+  Int         iBasePosX   = Clip3( 0, pcBasePdm->getWidth () - 1, iCurrPosX + ( ( iDisparity + iAddX ) >> iShiftX ) );
+  Int         iBasePosY   = Clip3( 0, pcBasePdm->getHeight() - 1, iCurrPosY                               );
+  Int         iBaseCUAddr;
+  Int         iBaseAbsPartIdx;
+  pcBaseRec->getCUAddrAndPartIdx( iBasePosX<< m_uiSubSampExpX , iBasePosY<< m_uiSubSampExpY , iBaseCUAddr, iBaseAbsPartIdx );
+#endif 
+
+  TComDataCU* pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
+
+  if( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTER || pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_SKIP )
+  {
+    for( UInt uiBaseRefListId = 0; uiBaseRefListId < 2; uiBaseRefListId++ )
+    {
+      RefPicList  eBaseRefPicList = RefPicList( uiBaseRefListId );
+      TComMvField cBaseMvField;
+      pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
+      Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
+
+      if (iBaseRefIdx >= 0)
+      {
+        Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
+        if (iBaseRefPOC != pcSlice->getPOC())    
+        {
+          for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eBaseRefPicList ); iPdmRefIdx++)
+          {
+            if (iBaseRefPOC == pcSlice->getRefPOC(eBaseRefPicList, iPdmRefIdx))
+            {
+              abPdmAvailable[ uiBaseRefListId ] = true;
+              paiPdmRefIdx  [ uiBaseRefListId ] = iPdmRefIdx;
+              TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
+#if LGE_DVMCP
+              cMv.m_bDvMcp = true;
+              cMv.m_iDvMcpDispX = pDInfo->m_acMvCand[0].getHor();
+#endif
+              pcCU->clipMv( cMv );
+              pacPdmMv      [ uiBaseRefListId ] = cMv;
+              break;
+            }
+          }
+        }
+      }
+    }
+  }
+  Int iPdmInterDir = ( abPdmAvailable[0] ? 1 : 0 ) + ( abPdmAvailable[1] ? 2 : 0 );
+
+  if (iPdmInterDir == 0)
+  {
+    for( Int iRefListId = 0; iRefListId < 2 ; iRefListId++ )
+    {
+      RefPicList  eRefPicList       = RefPicList( iRefListId );
+      Int         iNumRefPics       = pcSlice->getNumRefIdx( eRefPicList );
+      for( Int iPdmRefIdx = 0; iPdmRefIdx < iNumRefPics; iPdmRefIdx++ )
+{
+        if( pcSlice->getRefPOC( eRefPicList, iPdmRefIdx ) == pcSlice->getPOC())
+        {
+          abPdmAvailable[ iRefListId ] = true;
+          paiPdmRefIdx  [ iRefListId ] = iPdmRefIdx;
+#if QC_MULTI_DIS_CAN
+          TComMv cMv = pDInfo->m_acMvCand[0]; 
+          cMv.setVer(0);
+#else
+          TComMv cMv(iDisparity, 0);
+#endif
+          pcCU->clipMv( cMv );
+          pacPdmMv      [ iRefListId ] = cMv;
+          break;
+        }
+      }
+    }
+    iPdmInterDir = ( abPdmAvailable[0] ? 1 : 0 ) + ( abPdmAvailable[1] ? 2 : 0 ) ;
+  }
+
+  return iPdmInterDir;
+
+#else
   Int  iMaxNumInterPics  = 1;
   Int  iMaxNumAllPics    = 2;
@@ -580,5 +770,9 @@
       if( pcCU->getSlice()->getRefPOC( eRefPicList, iPdmRefIdx ) != pcCU->getSlice()->getPOC() )
       {
+#if QC_MULTI_DIS_CAN
+        if( getDisCanPdmMvPred (pcCU, uiPartIdx, eRefPicList, iPdmRefIdx, cMv, pDInfo, true ) )       
+#else 
         if( getPdmMvPred( pcCU, uiPartIdx, eRefPicList, iPdmRefIdx, cMv, true ) )
+#endif
         {
           pcCU->clipMv( cMv );
@@ -602,5 +796,9 @@
       for( Int iPdmRefIdx = 0; iPdmRefIdx < iNumRefPics; iPdmRefIdx++ )
       {
+#if QC_MULTI_DIS_CAN
+        if ( getDisCanPdmMvPred (pcCU, uiPartIdx, eRefPicList, iPdmRefIdx, cMv, pDInfo, true ) ) 
+#else 
         if( getPdmMvPred( pcCU, uiPartIdx, eRefPicList, iPdmRefIdx, cMv, true ) )
+#endif
         {
           pcCU->clipMv( cMv );
@@ -615,7 +813,97 @@
   }
   return iPdmInterDir;
-}
-
-
+#endif
+}
+
+#if QC_MULTI_DIS_CAN
+Bool
+TComDepthMapGenerator::getDisCanPdmMvPred    ( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge )
+{
+#if LGE_DVMCP
+  rcMv.m_bDvMcp = false;
+#endif
+  AOF  ( m_bCreated && m_bInit );
+  AOF  ( iRefIdx >= 0 );
+  AOF  ( pcCU );
+  //ROFRS( m_bPDMAvailable, false );
+  TComSlice*    pcSlice     = pcCU->getSlice ();
+  TComSPS*      pcSPS       = pcSlice->getSPS();
+  AOF  ( pcSPS->getViewId() == m_uiCurrViewId );
+  TComPic*      pcRefPic    = pcSlice->getRefPic( eRefPicList, iRefIdx );
+  UInt          uiRefViewId = pcRefPic->getSPS()->getViewId();
+  Int           iRefPoc     = pcRefPic->getPOC();
+  Bool          bInterview  = ( uiRefViewId < m_uiCurrViewId );
+  AOT(  bInterview && iRefPoc != pcSlice->getPOC() );
+  AOT( !bInterview && iRefPoc == pcSlice->getPOC() );
+  Bool          bPdmIView   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_IVIEW ) == PDM_USE_FOR_IVIEW );
+  Bool          bPdmInter   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_INTER ) == PDM_USE_FOR_INTER );
+  Bool          bPdmMerge   = ( ( pcSPS->getMultiviewMvPredMode() & PDM_USE_FOR_MERGE ) == PDM_USE_FOR_MERGE );
+  ROTRS( ( bInterview && !bMerge ) && !bPdmIView, false );
+  ROTRS( (!bInterview && !bMerge ) && !bPdmInter, false );
+  ROTRS(                  bMerge   && !bPdmMerge, false );
+  Int  iCurrPosX, iCurrPosY;
+  TComMv cDisMv;
+
+  if( bInterview )
+  {
+    rcMv = pDInfo->m_acMvCand[0]; 
+    rcMv.setVer(0);
+    return      true;
+  }
+  for( UInt uiBId = 0; uiBId < m_uiCurrViewId; uiBId++ )
+  {
+    UInt        uiBaseId    = uiBId;  //m_auiBaseIdList[ uiBId ];
+
+    if (m_uiCurrViewId >1 && uiBaseId ==1 ) 
+      continue;
+
+    TComPic*    pcBasePic   = m_pcAUPicAccess->getPic( uiBaseId );
+    TComPicYuv* pcBaseRec   = pcBasePic->getPicYuvRec   ();
+    UInt          uiPartAddr;
+    Int           iWidth;
+    Int           iHeight;
+
+    pcCU->getPartIndexAndSize( uiPartIdx, uiPartAddr, iWidth, iHeight );
+    pcBaseRec->getTopLeftSamplePos( pcCU->getAddr(), pcCU->getZorderIdxInCU() + uiPartAddr, iCurrPosX, iCurrPosY );
+    iCurrPosX  += ( ( iWidth  - 1 ) >> 1 );
+    iCurrPosY  += ( ( iHeight - 1 ) >> 1 );
+    Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (pDInfo->m_acMvCand[0].getHor() + 2 ) >> 2 ) );
+    Int         iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCurrPosY + ( (pDInfo->m_acMvCand[0].getVer() + 2 ) >> 2 ));  
+    Int         iBaseCUAddr;
+    Int         iBaseAbsPartIdx;
+    pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY , iBaseCUAddr, iBaseAbsPartIdx );
+    TComDataCU* pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
+    if( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) != MODE_INTER && pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) != MODE_SKIP )
+    {
+      continue;
+    }
+    for( UInt uiBaseRefListId = 0; uiBaseRefListId < 2; uiBaseRefListId++ )
+    {
+      RefPicList  eBaseRefPicList = RefPicList( uiBaseRefListId );
+      TComMvField cBaseMvField;
+      pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
+      Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
+      Int         iBaseRefPoc     = ( iBaseRefIdx >= 0 ? pcBaseCU->getSlice()->getRefPic( eBaseRefPicList, iBaseRefIdx )->getPOC() : -(1<<30) );
+      if( iBaseRefIdx >= 0 && iBaseRefPoc == iRefPoc )
+      {
+        rcMv.set( cBaseMvField.getHor(), cBaseMvField.getVer() );
+#if LGE_DVMCP
+        // save disparity vector when a merge candidate for IVMP is set as DV-MCP
+        if( bMerge ) 
+        {
+          rcMv.m_bDvMcp = true;
+          rcMv.m_iDvMcpDispX = pDInfo->m_acMvCand[0].getHor(); 
+        }
+        else { // AMVP ?
+          rcMv.m_bDvMcp = false;
+        }
+#endif
+        return true;
+      }
+    }
+  }
+  return false;
+}
+#else
 Bool  
 TComDepthMapGenerator::getPdmMvPred( TComDataCU* pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, Bool bMerge )
@@ -664,4 +952,8 @@
     //--- get base CU/PU and check prediction mode ---
     UInt        uiBaseId    = m_auiBaseIdList[ uiBId ];
+#if PDM_REMOVE_DEPENDENCE
+    if( uiBaseId != 0)
+      continue;
+#endif
     TComPic*    pcBasePic   = m_pcAUPicAccess->getPic( uiBaseId );
     TComPicYuv* pcBasePdm   = pcBasePic->getPredDepthMap();
@@ -697,4 +989,5 @@
   return false;
 }
+#endif
 
 
@@ -744,5 +1037,5 @@
 
 
-
+#if !QC_MULTI_DIS_CAN
 /*=======================================================*
  *=====                                             =====*
@@ -760,6 +1053,12 @@
   AOF( pcRef->getPredDepthMap()->getWidth () == pcCur->getPredDepthMap()->getWidth () );
   AOF( pcRef->getPredDepthMap()->getHeight() == pcCur->getPredDepthMap()->getHeight() );
-
+#if PDM_REMOVE_DEPENDENCE
+  if( pcCur->getViewId() == 1)
+    xClearDepthMap( pcRef );
+  else if (pcCur->getViewId() == 2)
+    xClearDepthMap( pcRef, PDM_UNDEFINED_DEPTH, 1 );
+#else
   xClearDepthMap( pcRef );
+#endif
   TComPicYuv* pcCurDepthMap =  pcCur->getPredDepthMap    ();
   TComPicYuv* pcRefDepthMap =  pcRef->getPredDepthMap    ();
@@ -771,4 +1070,11 @@
   Pel*        pRefSamples   =  pcRefDepthMap->getLumaAddr( 0 );
   Int         iRefViewIdx   =  pcRef->getViewId();
+#if PDM_REMOVE_DEPENDENCE
+  if( pcCur->getViewId() == 2)
+  {
+    pcRefDepthMap =  pcRef->getPredDepthMapTemp();
+    pRefSamples   =  pcRefDepthMap->getLumaAddr( 0 );
+  }
+#endif 
   Int         iShiftX       = m_uiSubSampExpX + 2;
   Int         iAddX         = ( 1 << iShiftX ) >> 1;
@@ -799,5 +1105,15 @@
   AOF( pcCur->getSPS()->getViewId()  > pcRef->getSPS()->getViewId() );
   AOF( pcCur->getPredDepthMap() );
+#if PDM_REMOVE_DEPENDENCE
+  if(pcCur->getViewId() == 1)
+  {
+    AOF( pcRef->getPredDepthMap() );
+  }else
+  {
+    AOF( pcRef->getPredDepthMapTemp() );
+  }
+#else
   AOF( pcRef->getPredDepthMap() );
+#endif
   AOF( pcRef->getPredDepthMap()->getWidth () == pcCur->getPredDepthMap()->getWidth () );
   AOF( pcRef->getPredDepthMap()->getHeight() == pcCur->getPredDepthMap()->getHeight() );
@@ -805,4 +1121,8 @@
   xClearDepthMap( pcCur );
   TComPicYuv* pcRefDepthMap =  pcRef->getPredDepthMap    ();
+#if PDM_REMOVE_DEPENDENCE
+  if(pcCur->getViewId() == 2)
+    pcRefDepthMap =  pcRef->getPredDepthMapTemp        ();
+#endif
   TComPicYuv* pcCurDepthMap =  pcCur->getPredDepthMap    ();
   Int         iWidth        =  pcRefDepthMap->getWidth   ();
@@ -844,6 +1164,15 @@
   }
   Bool    bUndefined = xFillDepthMapHoles( pcPic );
+#if PDM_REMOVE_DEPENDENCE
+  if(pcPic->getStoredPDMforV2() == 1){
+  pcPic->getPredDepthMapTemp()->setBorderExtension( false );
+  pcPic->getPredDepthMapTemp()->extendPicBorder   ();
+  }else{
+#endif
   pcPic->getPredDepthMap()->setBorderExtension( false );
   pcPic->getPredDepthMap()->extendPicBorder   ();
+#if PDM_REMOVE_DEPENDENCE
+  }
+#endif
   return  bUndefined;
 }
@@ -855,4 +1184,8 @@
   Bool        bUndefined  = false;      
   TComPicYuv* pcDepthMap  = pcPic->getPredDepthMap  ();
+#if PDM_REMOVE_DEPENDENCE
+  if(pcPic->getViewId()==0 && pcPic->getStoredPDMforV2()==1)
+    pcDepthMap  = pcPic->getPredDepthMapTemp  ();
+#endif
   Int         iWidth      = pcDepthMap->getWidth    ();
   Int         iHeight     = pcDepthMap->getHeight   ();
@@ -888,5 +1221,5 @@
         {
           bUndefined = true;
-		  break;
+          break;
         }
         iX = iE - 1;
@@ -913,5 +1246,10 @@
 
 Void
-TComDepthMapGenerator::xClearDepthMap( TComPic* pcPic, Int iVal )
+TComDepthMapGenerator::xClearDepthMap( TComPic* pcPic, Int iVal 
+#if PDM_REMOVE_DEPENDENCE
+,
+Int forFirstNonBaseView
+#endif
+)
 {
   TComPicYuv* pcDepthMap  = pcPic->getPredDepthMap  ();
@@ -920,4 +1258,11 @@
   Int         iStride     = pcDepthMap->getStride   ();
   Pel*        pDMSamples  = pcDepthMap->getLumaAddr ( 0 );
+#if PDM_REMOVE_DEPENDENCE
+  if( forFirstNonBaseView == 1)
+  {
+    pcDepthMap  = pcPic->getPredDepthMapTemp  ();
+    pDMSamples  = pcDepthMap->getLumaAddr ( 0 );
+  }
+#endif
   for( Int iY = 0; iY < iHeight; iY++, pDMSamples += iStride )
   {
@@ -989,4 +1334,8 @@
   TComYuv*    pcSubDM   = m_ppcYuv[ uiDepth ];
   TComPicYuv* pcPicDM   = pcCU->getPic()->getPredDepthMap();
+#if PDM_REMOVE_DEPENDENCE
+  if( pcCU->getPic()->getStoredPDMforV2() == 1)
+    pcPicDM   = pcCU->getPic()->getPredDepthMapTemp();
+#endif
   UInt        uiCUAddr  = pcCU->getAddr();
   pcSubCU->copySubCU( pcCU, uiAbsPartIdx, uiDepth );
@@ -1075,4 +1424,8 @@
     UInt  uiZOrderIdx     = pcCU->getZorderIdxInCU() + uiAbsPartIdx;
     Pel*  pPicDepthMap    = pcCU->getPic()->getPredDepthMap()->getLumaAddr( pcCU->getAddr(), uiZOrderIdx );
+#if PDM_REMOVE_DEPENDENCE
+    if(pcCU->getPic()->getStoredPDMforV2()==1)
+      pPicDepthMap    = pcCU->getPic()->getPredDepthMapTemp()->getLumaAddr( pcCU->getAddr(), uiZOrderIdx );
+#endif
     Int   iPicStride      = pcCU->getPic()->getPredDepthMap()->getStride  ();
     for( UInt uiY = 0; uiY < uiHeight; uiY++, pDepthMap += uiStride, pPicDepthMap += iPicStride )
@@ -1511,4 +1864,5 @@
   return        true;
 }
+#endif
 
 #endif // DEPTH_MAP_GENERATION
Index: trunk/source/Lib/TLibCommon/TComDepthMapGenerator.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 100)
@@ -136,7 +136,9 @@
 
   Void  initViewComponent     ( TComPic*      pcPic );
+#if !QC_MULTI_DIS_CAN
   Bool  predictDepthMap       ( TComPic*      pcPic );
   Void  updateDepthMap        ( TComPic*      pcPic );
   Void  dumpDepthMap          ( TComPic*      pcPic, char* pFilenameBase );
+#endif
 
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -149,6 +151,12 @@
   Int   getDisparity          ( TComPic*      pcPic, Int iPosX, Int iPosY, UInt uiRefViewId );
 #if HHI_INTER_VIEW_MOTION_PRED
+#if QC_MULTI_DIS_CAN
+  Int   getPdmMergeCandidate ( TComDataCU*   pcCU, UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo );
+  Bool  getPdmMvPredDisCan    ( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge );
+  Bool  getDisCanPdmMvPred    ( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge );
+#else
   Int   getPdmMergeCandidate  ( TComDataCU*   pcCU, UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv );
   Bool  getPdmMvPred          ( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, Bool bMerge );
+#endif
   Bool  getIViewOrgDepthMvPred( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv );
 #endif
@@ -163,9 +171,15 @@
 private:
   // picture operations
+#if !QC_MULTI_DIS_CAN
   Bool  xConvertDepthMapCurr2Ref  ( TComPic*    pcRef, TComPic* pcCur );
   Bool  xConvertDepthMapRef2Curr  ( TComPic*    pcCur, TComPic* pcRef );
   Bool  xPredictDepthMap          ( TComPic*    pcPic );
   Bool  xFillDepthMapHoles        ( TComPic*    pcPic );
-  Void  xClearDepthMap            ( TComPic*    pcPic, Int      iVal  = PDM_UNDEFINED_DEPTH );
+  Void  xClearDepthMap            ( TComPic*    pcPic, Int      iVal  = PDM_UNDEFINED_DEPTH
+#if PDM_REMOVE_DEPENDENCE
+  ,
+  Int forFirstNonBaseView = 0
+#endif
+  );
   Void  xSetChroma                ( TComPicYuv* pcPic, Int      iVal  );
 
@@ -182,5 +196,5 @@
   Void  xInterPUDepthMapPrediction( TComDataCU* pcCU, TComYuv* pcCUDepthMap, UInt uiPartIdx );                      // PU inter prediction
   Bool  xGetPredDepth             ( TComDataCU* pcCU, UInt uiPartIdx, Int& riPrdDepth, Int* piPosX = 0, Int* piPosY = 0 );
-
+#endif
   // conversion functions
   Int   xGetVirtDepthFromDisparity( UInt uiBaseId, Int iDisparity )
Index: trunk/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 100)
@@ -59,4 +59,12 @@
 
 // ====================================================================================================================
+#if QC_MULTI_DIS_CAN
+typedef struct _DisCand
+{
+  TComMv m_acMvCand[ DIS_CANS ];            ///< array of motion vector predictor candidates
+  Int    m_aVIdxCan[ DIS_CANS ];            ///< array of motion vector predictor candidates
+  Int    iN;                                ///< number of motion vector predictor candidates
+} DisInfo;
+#endif 
 // Class definition
 // ====================================================================================================================
Index: trunk/source/Lib/TLibCommon/TComMv.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComMv.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComMv.h	(revision 100)
@@ -57,4 +57,9 @@
 public:
   
+#if LGE_DVMCP
+  Bool  m_bDvMcp;       // is dv-mcp ?
+  Int   m_iDvMcpDispX;  // disparity for dv-mcp
+#endif
+
   // ------------------------------------------------------------------------------------------------------------------
   // constructors
@@ -64,4 +69,8 @@
   m_iHor(0),
   m_iVer(0)
+#if LGE_DVMCP
+  , m_bDvMcp(false)
+  , m_iDvMcpDispX(0)
+#endif
   {
   }
@@ -70,4 +79,8 @@
   m_iHor(iHor),
   m_iVer(iVer)
+#if LGE_DVMCP
+  , m_bDvMcp(false)
+  , m_iDvMcpDispX(0)
+#endif
   {
   }
Index: trunk/source/Lib/TLibCommon/TComPattern.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPattern.cpp	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComPattern.cpp	(revision 100)
@@ -675,4 +675,7 @@
 {
   Int* piSrc;
+#if LGE_EDGE_INTRA
+  mapEdgeIntratoDC( uiDirMode );
+#endif
   assert(log2BlkSize >= 2 && log2BlkSize < 7);
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
Index: trunk/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 100)
@@ -55,4 +55,7 @@
 #if DEPTH_MAP_GENERATION
   m_pcPredDepthMap    = NULL;
+#if PDM_REMOVE_DEPENDENCE
+  m_pcPredDepthMap_temp    = NULL;
+#endif
 #endif
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -136,4 +139,12 @@
     m_pcPredDepthMap = NULL;
   }
+#if PDM_REMOVE_DEPENDENCE
+  if( m_pcPredDepthMap_temp )         //  estimated depth map
+  {
+    m_pcPredDepthMap_temp->destroy();
+    delete m_pcPredDepthMap_temp;
+    m_pcPredDepthMap_temp = NULL;
+  }                     
+#endif
 #endif
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -179,4 +190,8 @@
   m_pcPredDepthMap    = new TComPicYuv;
   m_pcPredDepthMap    ->create( iWidth >> uiSubSampExpX, iHeight >> uiSubSampExpY, uiMaxCuWidth >> uiSubSampExpX, uiMaxCuHeight >> uiSubSampExpY, uiMaxCuDepth );
+#if PDM_REMOVE_DEPENDENCE
+  m_pcPredDepthMap_temp    = new TComPicYuv;
+  m_pcPredDepthMap_temp    ->create( iWidth >> uiSubSampExpX, iHeight >> uiSubSampExpY, uiMaxCuWidth >> uiSubSampExpX, uiMaxCuHeight >> uiSubSampExpY, uiMaxCuDepth );
+#endif
 }
 #endif
@@ -224,4 +239,12 @@
     m_pcPredDepthMap = NULL;
   }
+#if PDM_REMOVE_DEPENDENCE
+  if(m_pcPredDepthMap_temp)
+  {
+    m_pcPredDepthMap_temp->destroy();
+    delete m_pcPredDepthMap_temp;
+    m_pcPredDepthMap_temp = NULL;
+  }
+#endif
 }
 #endif
Index: trunk/source/Lib/TLibCommon/TComPic.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComPic.h	(revision 100)
@@ -67,8 +67,19 @@
 #if DEPTH_MAP_GENERATION
   TComPicYuv*           m_pcPredDepthMap;         //  estimated depth map
+#if PDM_REMOVE_DEPENDENCE
+  TComPicYuv*           m_pcPredDepthMap_temp;         //  estimated depth map
+  Bool                  m_bPDMV2;                       
+#endif
+#endif
+
+#if LG_ZEROINTRADEPTHRESI_M26039
+  Int                   m_uiIntraPeriod;
 #endif
 
 #if HHI_INTER_VIEW_MOTION_PRED
   TComPicYuv*           m_pcOrgDepthMap;          //  original depth map
+#if QC_MULTI_DIS_CAN
+  Bool          m_checked;
+#endif
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -123,8 +134,12 @@
   TComVPS*      getVPS()              { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getVPS();  }
 #endif
+#if LG_ZEROINTRADEPTHRESI_M26039
+  Int           getIntraPeriod()                           { return  m_uiIntraPeriod; }
+  Void          setIntraPeriod(Int uiIntraPeriod)          { m_uiIntraPeriod = uiIntraPeriod; }
+#endif
   TComSPS*      getSPS()              { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getSPS();  }
   Int           getPOC()              { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getPOC();  }
   Int           getViewId()           { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getViewId(); }
-  TComDataCU*&  getCU( UInt uiCUAddr )  { return  m_apcPicSym->getCU( uiCUAddr ); }
+  TComDataCU*&  getCU( UInt uiCUAddr ){ return  m_apcPicSym->getCU( uiCUAddr ); }
   
   TComPicYuv*   getPicYuvOrg()        { return  m_apcPicYuv[0]; }
@@ -136,8 +151,17 @@
 #if DEPTH_MAP_GENERATION
   TComPicYuv*   getPredDepthMap()     { return  m_pcPredDepthMap; }
-#endif
-
+#if PDM_REMOVE_DEPENDENCE
+  TComPicYuv*   getPredDepthMapTemp()           { return  m_pcPredDepthMap_temp; }
+  Void          setStoredPDMforV2  (Bool flag)  { m_bPDMV2 = flag;}
+  Bool          getStoredPDMforV2  ()           { return m_bPDMV2;}
+#endif
+
+#endif
 #if HHI_INTER_VIEW_MOTION_PRED
   TComPicYuv*   getOrgDepthMap()      { return  m_pcOrgDepthMap; }
+#if QC_MULTI_DIS_CAN
+  Void          setCandPicCheckedFlag (Bool bchecked)   { m_checked = bchecked; }
+  Bool          getCandPicCheckedFlag ()                { return m_checked;}
+#endif
 #endif
 
